package Manager;

import Database.DatabaseClient;
import java.sql.*;

public class Furniture {
    private DatabaseClient DB;
    public int Id;
    public String Name;
    public String Type;
    public int Width;
    public int Length;
    public String StackHeight;
    public int CanStack;
    public int CanSit;
    public int IsWalkable;
    public int SpriteId;
    public int AllowRecycle;
    public int AllowTrade;
    public int AllowMarketplace;
    public int AllowGift;
    public int AllowInventoryStack;
    public String Interaction;
    public int InteractionModes;
    public String[] DrinkIds;

    public Furniture(int furnid, DatabaseClient db){
        try{
        Id = furnid;
        DB = db;
        ResultSet myQuery = DB.Query("SELECT * FROM furniture WHERE id = '" + furnid + "'");
        myQuery.next();

        Name = myQuery.getString("item_name");
        Type = myQuery.getString("type");
        Width = myQuery.getInt("width");
        Length = myQuery.getInt("length");
        StackHeight = myQuery.getString("stack_height");
        CanStack = myQuery.getInt("can_stack");
        CanSit = myQuery.getInt("can_sit");
        IsWalkable = myQuery.getInt("is_walkable");
        SpriteId = myQuery.getInt("sprite_id");
        AllowRecycle = myQuery.getInt("allow_recycle");
        AllowTrade = myQuery.getInt("allow_trade");
        AllowMarketplace = myQuery.getInt("allow_marketplace_sell");
        AllowGift = myQuery.getInt("allow_gift");
        AllowInventoryStack = myQuery.getInt("allow_inventory_stack");
        Interaction = myQuery.getString("interaction_type");
        InteractionModes = myQuery.getInt("interaction_modes_count");
        DrinkIds = myQuery.getString("vending_ids").split(",");
        }catch(Exception con){}
    }
}
